diff -ur dia-0.83-5/app/render_eps.c dia-0.83-5after/app/render_eps.c
--- dia-0.83-5/app/render_eps.c	Sat Jan 29 18:12:53 2000
+++ dia-0.83-5after/app/render_eps.c	Sat Jan 29 00:04:10 2000
@@ -1089,20 +1089,19 @@
       buff[s] = text[i];
       _pos.x += font_string_width(buff, font, height);
     }
-    if (text[i-1] > 0) {
-      /* printing ASCII chars */
-      set_font(renderer, font, height);
-    } else {
-      /* printging 16bits chars */
-      set_mbfont(renderer, font, height);
-    }
+  }
+  if (text[i-1] > 0) {
+    /* printing ASCII chars */
+    set_font(renderer, font, height);
+  } else {
+    /* printging 16bits chars */
+    set_mbfont(renderer, font, height);
   }
   buff[s] = '\0';
   draw_string(renderer,
  	      buff,
 	      &_pos, alignment,
  	      color);
-  _pos = *pos;
   g_free(buff);
 }
 
diff -ur dia-0.83-5/lib/text.c dia-0.83-5after/lib/text.c
--- dia-0.83-5/lib/text.c	Sat Jan 29 18:12:25 2000
+++ dia-0.83-5after/lib/text.c	Sat Jan 29 18:10:37 2000
@@ -577,11 +577,19 @@
       text_join_lines(text, row);
     return;
   }
-  memmove(text->line[row] + text->cursor_pos,
-	  text->line[row] + text->cursor_pos + 1,
-	  text->strlen[row] - text->cursor_pos);
+  if(text->line[row][text->cursor_pos+1] > 0) {
+    memmove(text->line[row] + text->cursor_pos,
+	    text->line[row] + text->cursor_pos + 1,
+	    text->strlen[row] - text->cursor_pos);
+
+    text->strlen[row]--;
+  } else {
+    memmove(text->line[row] + text->cursor_pos,
+	    text->line[row] + text->cursor_pos + 2,
+	    text->strlen[row] - text->cursor_pos);
 
-  text->strlen[row]--;
+    text->strlen[row]-=2;
+  }
   
   if (text->cursor_pos > text->strlen[text->cursor_row])
     text->cursor_pos = text->strlen[text->cursor_row];
@@ -600,6 +608,7 @@
   int row;
   int i;
   real width;
+  gchar *tmp_c;
   
   row = text->cursor_row;
   
@@ -608,13 +617,24 @@
       text_join_lines(text, row-1);
     return;
   }
-  memmove(text->line[row] + text->cursor_pos - 1,
-	  text->line[row] + text->cursor_pos,
-	  text->strlen[row] - text->cursor_pos + 1);
+  
+  if(text->line[row][text->cursor_pos-1] > 0) {
+    memmove(text->line[row] + text->cursor_pos - 1,
+	    text->line[row] + text->cursor_pos,
+	    text->strlen[row] - text->cursor_pos + 1);
+    text->strlen[row]--;
+
+    text->cursor_pos --;
+
+  } else {
+    memmove(text->line[row] + text->cursor_pos - 2,
+	    text->line[row] + text->cursor_pos,
+	    text->strlen[row] - text->cursor_pos + 1);
+    text->strlen[row]-=2;
 
-  text->strlen[row]--;
+    text->cursor_pos -=2;
+  }
 
-  text->cursor_pos --;
   
   if (text->cursor_pos > text->strlen[text->cursor_row])
     text->cursor_pos = text->strlen[text->cursor_row];
@@ -749,12 +769,20 @@
     
     break;
   case GDK_Left:
-    text->cursor_pos--;
+    if(text->line[text->cursor_row][text->cursor_pos-1] > 0) {
+      text->cursor_pos--;
+    } else {
+      text->cursor_pos-=2;
+    }
     if (text->cursor_pos<0)
       text->cursor_pos = 0;
     break;
   case GDK_Right:
-    text->cursor_pos++;
+    if(text->line[text->cursor_row][text->cursor_pos+1] > 0) {
+      text->cursor_pos++;
+    } else {
+      text->cursor_pos+=2;
+    }
     if (text->cursor_pos > text->strlen[text->cursor_row])
       text->cursor_pos = text->strlen[text->cursor_row];
     break;
 
